/*-
 * Copyright (c) 2006, 2007 CTPP Team
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 4. Neither the name of the CTPP Team nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *      HashTest.hpp
 *
 * $CTPP$
 */
#include <CDT.hpp>

#include <stdio.h>

#ifdef HAVE_SYSEXITS_H
#include <sysexits.h>
#endif

using namespace CTPP;


int main(void)
{

	CDT oCDT_int   = 10;

	fprintf(stderr, "== INT   ===================================\n");
	{
		fprintf(stderr, "Post-increnent\n");
		CDT oTMP = oCDT_int++;
		fprintf(stderr, "TMP = CDT++\n");
		fprintf(stderr, "TMP ->    %d\n",   INT_32(oTMP.GetInt()));
		fprintf(stderr, "CDT ->    %d\n\n", INT_32(oCDT_int.GetInt()));
	}

	{
		fprintf(stderr, "Pre-increnent\n");
		CDT oTMP = ++oCDT_int;
		fprintf(stderr, "TMP = ++CDT\n");
		fprintf(stderr, "TMP ->    %d\n",   INT_32(oTMP.GetInt()));
		fprintf(stderr, "CDT ->    %d\n\n", INT_32(oCDT_int.GetInt()));
	}

	{
		fprintf(stderr, "Post-decrement\n");
		CDT oTMP = oCDT_int--;
		fprintf(stderr, "TMP = CDT--\n");
		fprintf(stderr, "TMP ->    %d\n",   INT_32(oTMP.GetInt()));
		fprintf(stderr, "CDT ->    %d\n\n", INT_32(oCDT_int.GetInt()));
	}

	{
		fprintf(stderr, "Pre-decrement\n");
		CDT oTMP = --oCDT_int;
		fprintf(stderr, "TMP = --CDT\n");
		fprintf(stderr, "TMP ->    %d\n",   INT_32(oTMP.GetInt()));
		fprintf(stderr, "CDT ->    %d\n\n", INT_32(oCDT_int.GetInt()));
	}

	oCDT_int += 10;
	fprintf(stderr, "CDT += 10 -> %d\n",   INT_32(oCDT_int.GetInt()));
	oCDT_int -= 10;
	fprintf(stderr, "CDT -= 10 -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int *= 10;
	fprintf(stderr, "CDT *=    -> %d\n",   INT_32(oCDT_int.GetInt()));
	oCDT_int /= 10;
	fprintf(stderr, "CDT /=    -> %d\n\n", INT_32(oCDT_int.GetInt()));

	oCDT_int = oCDT_int + 10;
	fprintf(stderr, "CDT = CDT + 10  -> %d\n",   INT_32(oCDT_int.GetInt()));
	oCDT_int = 10 + oCDT_int;
	fprintf(stderr, "CDT = 10 + CDT  -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int = oCDT_int - 10;
	fprintf(stderr, "CDT = CDT - 10  -> %d\n",   INT_32(oCDT_int.GetInt()));
	oCDT_int = 10 - oCDT_int;
	fprintf(stderr, "CDT = 10 - CDT  -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int = oCDT_int + 210;
	fprintf(stderr, "CDT = CDT + 210 -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int = oCDT_int / 100;
	fprintf(stderr, "CDT = CDT / 100 -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int = 10 / oCDT_int;
	fprintf(stderr, "CDT = 10 / CDT  -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int = 10 * oCDT_int;
	fprintf(stderr, "CDT = 10 * CDT  -> %d\n",   INT_32(oCDT_int.GetInt()));

	oCDT_int = oCDT_int * 2;
	fprintf(stderr, "CDT = CDT * 2   -> %d\n\n", INT_32(oCDT_int.GetInt()));

	{
		CDT oCDT1   = 10;
		CDT oCDT2   = 10.0;
		fprintf(stderr, "%f == %f === '%c'\n", oCDT1.GetFloat(), oCDT2.GetFloat(), (oCDT1 == oCDT2) ? 't':'f');
		fprintf(stderr, "%f >= %f === '%c'\n", oCDT1.GetFloat(), oCDT2.GetFloat(), (oCDT1 >= oCDT2) ? 't':'f');
		fprintf(stderr, "%f <= %f === '%c'\n", oCDT1.GetFloat(), oCDT2.GetFloat(), (oCDT1 <= oCDT2) ? 't':'f');
	}

	{
		CDT oCDT1   = 10;
		CDT oCDT2   = 10.1;
		fprintf(stderr, "%f != %f === '%c'\n",  oCDT1.GetFloat(), oCDT2.GetFloat(), (oCDT1 != oCDT2) ? 't':'f');
		fprintf(stderr, "%f >= %f === '%c'\n",   oCDT1.GetFloat(), oCDT2.GetFloat(), (oCDT1 > oCDT2) ? 't':'f');
		fprintf(stderr, "%f <= %f === '%c'\n\n", oCDT1.GetFloat(), oCDT2.GetFloat(), (oCDT1 < oCDT2) ? 't':'f');
	}

	{
		CDT oCDT1   = "abac";
		CDT oCDT2("caba");

		fprintf(stderr, "%s != %s === '%c'\n",  oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 != oCDT2) ? 't':'f');
		fprintf(stderr, "%s > %s === '%c'\n",   oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 > oCDT2) ? 't':'f');
		fprintf(stderr, "%s < %s === '%c'\n\n", oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 < oCDT2) ? 't':'f');
	}

	{
		CDT oCDT1   = "test";
		CDT oCDT2("test");

		fprintf(stderr, "%s == %s === '%c'\n",  oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 == oCDT2) ? 't':'f');
		fprintf(stderr, "%s >= %s === '%c'\n",   oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 >= oCDT2) ? 't':'f');
		fprintf(stderr, "%s <= %s === '%c'\n\n", oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 <= oCDT2) ? 't':'f');
	}

	{
		CDT oCDT("caba");

		fprintf(stderr, "%s == CCHAR_P %s === '%c'\n",  oCDT.GetString().c_str(), "caba", (oCDT == "caba") ? 't':'f');
		fprintf(stderr, "%s != CCHAR_P %s === '%c'\n",  oCDT.GetString().c_str(), "abac", (oCDT != "abac") ? 't':'f');
		fprintf(stderr, "%s > CCHAR_P %s === '%c'\n",   oCDT.GetString().c_str(), "caba", (oCDT > "caba") ? 't':'f');
		fprintf(stderr, "%s < CCHAR_P %s === '%c'\n\n", oCDT.GetString().c_str(), "caba", (oCDT < "caba") ? 't':'f');
	}


	{
		CDT oCDT1   = 1234;
		CDT oCDT2("1234");

		fprintf(stderr, "%s == %s === '%c'\n",  oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 == oCDT2) ? 't':'f');
		fprintf(stderr, "%s >= %s === '%c'\n",   oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 >= oCDT2) ? 't':'f');
		fprintf(stderr, "%s <= %s === '%c'\n\n", oCDT1.GetString().c_str(), oCDT2.GetString().c_str(), (oCDT1 <= oCDT2) ? 't':'f');
	}


	fprintf(stderr, "As String 1: `%s`\n",   oCDT_int.GetString("").c_str());
	fprintf(stderr, "As String 2: `%s`\n\n", oCDT_int.GetString("0x%08X").c_str());

	CDT oCDT_int1 = oCDT_int;
	CDT oCDT_int2(oCDT_int);


	oCDT_int = oCDT_int / 6.0;
	fprintf(stderr, "CDT = CDT / 6.0 (autoconvert to REAL): %f\n\n",   oCDT_int.GetFloat());

	fprintf(stderr, "== FLOAT ===================================\n");

	CDT oCDT_float   = 10.5;

	oCDT_float += 10;
	fprintf(stderr, "CDT += 10 ->   %f\n",   oCDT_float.GetFloat());
	oCDT_float -= 10;
	fprintf(stderr, "CDT -= 10 ->   %f\n",   oCDT_float.GetFloat());

	oCDT_float *= 10;
	fprintf(stderr, "CDT *= 10 ->   %f\n",   oCDT_float.GetFloat());
	oCDT_float /= 3;
	fprintf(stderr, "CDT /= 3  ->   %f\n\n",   oCDT_float.GetFloat());

	oCDT_float = oCDT_float + 10;
	fprintf(stderr, "CDT = CDT + 10 ->    %f\n",   oCDT_float.GetFloat());

	{
		CDT oCDT_float1 = oCDT_float + 10;
	}
	fprintf(stderr, "CDT = CDT + 10 ->    %f\n",   oCDT_float.GetFloat());

	oCDT_float = 10 + oCDT_float;
	fprintf(stderr, "CDT = 10 + CDT ->    %f\n",   oCDT_float.GetFloat());

	oCDT_float = oCDT_float - 10;
	fprintf(stderr, "CDT = CDT - 10 ->    %f\n",   oCDT_float.GetFloat());

	oCDT_float = 10 - oCDT_float;
	fprintf(stderr, "CDT = 10 - CDT ->    %f\n",   oCDT_float.GetFloat());

	oCDT_float = oCDT_float + 210;
	fprintf(stderr, "CDT = CDT + 210 ->   %f\n",   oCDT_float.GetFloat());

	oCDT_float = oCDT_float / 100;
	fprintf(stderr, "CDT = CDT / 100 ->   %f\n",   oCDT_float.GetFloat());

	oCDT_float = 10 / oCDT_float;
	fprintf(stderr, "CDT = 10 / CDT ->    %f\n",   oCDT_float.GetFloat());

	oCDT_float = 10 * oCDT_float;
	fprintf(stderr, "CDT = 10 * CDT ->    %f\n",   oCDT_float.GetFloat());

	oCDT_float = oCDT_float * 2;
	fprintf(stderr, "CDT = CD * 2   ->    %f\n",   oCDT_float.GetFloat());

	fprintf(stderr, "As String 1: `%s`\n",   oCDT_float.GetString("").c_str());
	fprintf(stderr, "As String 2: `%s`\n\n",   oCDT_float.GetString("%e").c_str());

	fprintf(stderr, "== POINTER ==================================\n");
	void * vTMP = (void *)0xDeadBeef;
	CDT oCDT_pointer(vTMP);
	fprintf(stderr, "As String 1: `%s`\n",   oCDT_pointer.GetString("").c_str());
	fprintf(stderr, "As String 2: `%s`\n\n",   oCDT_pointer.GetString("Pointer: %p").c_str());

	fprintf(stderr, "As Pointer 1: %p\n",   oCDT_pointer.GetPointer());
	fprintf(stderr, "As Pointer 2: %p\n\n",   (void *)(oCDT_pointer.GetObject<CHAR_P>()));

	fprintf(stderr, "== STRING ===================================\n");
	CDT oCDT_str = "Hello";
	oCDT_str += std::string(", ");
	oCDT_str.Append("World! 1-st Addition test: ");
	oCDT_str += oCDT_float;
	oCDT_str += std::string(", ");
	oCDT_str += 3.141592654;
	CDT oCDT_str1(oCDT_str);
	oCDT_str += std::string(", ");
	oCDT_str += 1977;

	fprintf(stderr, "As String 1: `%s`\n",   oCDT_str.GetString().c_str());
	fprintf(stderr, "As String 2: `%s`\n",   oCDT_str1.GetString().c_str());

	oCDT_str1 = oCDT_str;
	CDT oCDT_str2(oCDT_str1);

	oCDT_str += 1008;

	oCDT_str.Append(" 2-nd Addition test: ");
	oCDT_str += oCDT_int;

	fprintf(stderr, "As String 3: `%s`\n",   oCDT_str.GetString().c_str());
	fprintf(stderr, "As String 4: `%s`\n",   oCDT_str1.GetString().c_str());

	CDT sCaster = std::string(" <- to String ->");

	oCDT_float += sCaster;
	fprintf(stderr, "As String 5: `%s`\n",  oCDT_float.GetString().c_str());
	oCDT_int1 += sCaster;
	fprintf(stderr, "As String 6: `%s`\n",  oCDT_int1.GetString().c_str());

	oCDT_int1 = oCDT_int2 + sCaster;
	fprintf(stderr, "As String 7: `%s`\n",  oCDT_int2.GetString().c_str());
	fprintf(stderr, "As String 8: `%s`\n",  oCDT_int1.GetString().c_str());

	oCDT_str2 = oCDT_str2 + std::string("< to another string >");
	fprintf(stderr, "As String 7: `%s`\n",  oCDT_int1.GetString().c_str());

	oCDT_int1 = oCDT_int2 + sCaster;
	fprintf(stderr, "As String 8: `%s`\n",  oCDT_int1.GetString().c_str());
	fprintf(stderr, "As String 9: `%s`\n",  oCDT_int2.GetString().c_str());

	oCDT_int1 = std::string("<!>");
	oCDT_int1 = 10 + sCaster + 10;
	fprintf(stderr, "As String 10: `%s`\n",  oCDT_int1.GetString().c_str());

	{
		CDT oCDT_c_int(CDT::INT_VAL);
		CDT oCDT_c_float(CDT::REAL_VAL);
		CDT oCDT_c_string(CDT::STRING_VAL);

		oCDT_c_int = oCDT_c_float = oCDT_c_string = 10;
		fprintf(stderr, "Constructor `%f` `%f` `%f`\n", oCDT_c_int.GetFloat(), oCDT_c_float.GetFloat(), oCDT_c_string.GetFloat());
	}

	try
	{
		CDT oCDT_array(CDT::ARRAY_VAL);
		oCDT_array[0]  = 10;
		oCDT_array[1]  = 10.5;
		oCDT_array[2]  = "test";
		oCDT_array[3]  = "passed";
		oCDT_array[10] = 11;
		oCDT_array[11][3] = 5;

		fprintf(stderr, "ARRAY size: %d\n", oCDT_array.Size());
		for (UINT_32 iI = 0; iI < oCDT_array.Size(); ++iI)
		{
			fprintf(stderr, "oCDT_array[%d] (%s) = `%s`\n", iI, oCDT_array[iI].PrintableType(), oCDT_array[iI].GetString().c_str());
		}
		fprintf(stderr, "ARRAY size: %d\n\n", oCDT_array.Size());
	}
	catch(CDTTypeCastException &e)
	{
		fprintf(stderr, "ERROR: Type cast %s\n", e.what());
	}
	catch(std::exception &e)
	{
		fprintf(stderr, "ERROR: std %s\n", e.what());
	}
	catch(...)
	{
		fprintf(stderr, "Ouch!\n");
	}
/*
my %H;
$H{'q'} -> [1] -> {"test"} = "passed";
*/
	fprintf(stderr, "== ARRAYS & HASHES ==========================\n");
	CDT oCDT_array;
	oCDT_array["abc"]       = 10;
	oCDT_array["xyz"][0]    = 2;
	oCDT_array["1"]["2"][3] = 4;

	fprintf(stderr, "oCDT_array[\"abc\"]         (%s) = `%s`\n",   oCDT_array["abc"].PrintableType(),       oCDT_array["abc"].GetString().c_str());
	fprintf(stderr, "oCDT_array[\"1\"]           (%s) = `%s`\n",   oCDT_array["1"].PrintableType(),         oCDT_array["1"].GetString().c_str());
	fprintf(stderr, "oCDT_array[\"1\"][\"2\"]      (%s) = `%s`\n", oCDT_array["1"]["2"].PrintableType(),    oCDT_array["1"]["2"].GetString().c_str());
	fprintf(stderr, "oCDT_array[\"abc\"][\"2\"][3] (%s) = `%s`\n", oCDT_array["1"]["2"][3].PrintableType(), oCDT_array["1"]["2"][3].GetString().c_str());

	CDT oCDT_empty;

	fprintf(stderr, "oCDT_empty = `%s`\n\n", oCDT_empty["test"].GetString().c_str());

	fprintf(stderr, "DUMP: %s", oCDT_array.RecursiveDump().c_str());

	CDT::Iterator itCDTArray = oCDT_array.Begin();
	while (itCDTArray != oCDT_array.End())
	{
		fprintf(stderr, "oCDT_array[\"%s\"] => %s\n", itCDTArray -> first.c_str(), itCDTArray -> second.GetString().c_str());
		itCDTArray -> second = "Empty";
		++itCDTArray;
	}

	CDT::ConstIterator itCDTCArray = oCDT_array.Begin();
	while (itCDTCArray != oCDT_array.End())
	{
		fprintf(stderr, "oCDT_array[\"%s\"] => %s\n", itCDTCArray -> first.c_str(), itCDTCArray -> second.GetString().c_str());

		++itCDTCArray;
	}
	fprintf(stderr, "DUMP: %s", oCDT_array.RecursiveDump().c_str());

	CDT oCDT_array1(CDT::ARRAY_VAL);
	oCDT_array1.PushBack(1);
	oCDT_array1.PushBack(1.23);
	oCDT_array1.PushBack("some string");
	oCDT_array1.PushBack(oCDT_array);

	fprintf(stderr, "DUMP: %s", oCDT_array1.RecursiveDump().c_str());

	fprintf(stderr, "== END ======================================\n");

	// make valgrind happy
	fclose(stdin);
	fclose(stdout);
	fclose(stderr);

return EX_OK;
}
// End.

